package Orezavatko;


import java.io.BufferedWriter;

import java.io.FileWriter;
import java.io.IOException;
import java.lang.reflect.Array;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Map;
import java.util.TreeMap;

import javax.swing.JFrame;
import javax.swing.JOptionPane;


import txt_do_poctu.Castice;
import txt_do_poctu.MTSnimek;
import txt_do_poctu.typ_castice;
import umontreal.ssj.functionfit.LeastSquares;

// Tohle je hlavn tda na analzu dE/dx jednotlivch stic
public class Snimek1Castice extends OrezSnimek {

	LinkedList<Integer> souradnice_x = new LinkedList<Integer>();//vechny x souadnice bod
	LinkedList<Integer> souradnice_y = new LinkedList<Integer>();//vechny y souadnice bod



public void rozhled(int x, int y) { //upraven metoda rozhled, kter dl to sam + zapisuje si x a y souadnice
	super.rozhled(x, y);//zavoln metody rozhled rodie

	souradnice_x.addFirst(x);
    souradnice_y.addFirst(y); 
	
	
	

	
	
}

	public Snimek1Castice(double[][] pole, String way) throws IOException { // hlavn konstruktor tdy, je reprezentuje snmek s 1 stic a jej analzu
		                //jako argument je pedvno 2D pole s stic
		super();//metoda rodie
		int cislo_castice = 1;
		
		
		hlavni_pole = new double [rozmer_x] [rozmer_y];           //hlavn 2D pole
		sekundarni_pole = new double [rozmer_x] [rozmer_y];
		BufferedWriter bw = null;
		
		
		for(int i = 0;i < 256; i++ ) {                     //pepis 2D pole z argumentu do dvou 2D poli v metod
			for (int j = 0; j< 256; j++) {
				hlavni_pole [i] [j] = pole [i] [j];
				sekundarni_pole [i] [j] = pole [i] [j];
				
				
			}
			
			
		}
		
		
	
		Castice prubezna_castice;//pomocn objekt stice
		
		boolean overload = false; //promnn kontrolujc, zda se v souboru nachz opravdu jedna stice
		
	
		

		
		for(int i = 0; i < 256; i ++) { //prohledvn pole
	    	for(int j = 0; j < 256; j ++) {
	        if	(hlavni_pole[j][i] != 0) {
	        	if(overload) { //zachycen druh nedouc stice
	        		JOptionPane.showMessageDialog(null, "V jednom ze snmk se vyskytuje vce stic.", "InfoBox: " + "cetnost castic", JOptionPane.INFORMATION_MESSAGE);
	        		System.exit(1);
	        		
	        	}
	        	
	        	overload = true;
	        	
	      	zapisovaci_pole = new double[rozmer_x] [rozmer_y];//vytvoen novho pole pro 1 stici
	         	max_x = 0;                                    //resetovn max a min vech souadnic
	        	max_y = 0;
	        	min_x = 256;
	            min_y = 256;
	        	rozhled(j,i);	        		//rekurzivn funkce pro nalezen stice
	        	}
	        
	        	
	   	    
	        }
	        		
	        		
	        
	        		
	        	
	        	
	        	
	        	
	        }
	    	
	    		
	    	
	    	
	    	
	
			
			
			
			
		
		
		
	
		
		
		double [] X_ove = new double [souradnice_x.size()];
		double [] Y_ove = new double [souradnice_y.size()];
		int posuv = 0;
		
		for(int i = 0; i < souradnice_x.size();i++) {//pepis souadnic ze seznamu do 2D pol, metoda pro aproximaci pmky bere jen 2D pole
			X_ove [i] =  souradnice_x.get(i);
			Y_ove [i] = souradnice_y.get(i);
			System.out.println("x: " + souradnice_x.get(i) + "y " + souradnice_y.get(i) );
			
		}
		posuv = 0;
		
		double celko_energie = 0;
		for(int i = 0; i < souradnice_x.size();i++) { //souet vech bunk d celkovou energii
			
			
			 celko_energie =  celko_energie + sekundarni_pole [souradnice_x.get(i)] [souradnice_y.get(i)] ;
		}
		System.out.println("" + celko_energie);
		double [] a_b = new double [2]; //promnn pro uloen parametr pmky, je bude aproximovna pro smr stice
		
		a_b = LeastSquares.calcCoefficients(X_ove, Y_ove);// uplatnn metody nejmench tverc z knihovny SSJ pro aproximaci pmky, zskn parametr a i b
		
		
		
		posuv = 0;
		
		System.out.print("a: " + a_b[0]);
		System.out.print("b: " + a_b[1]);
		// potek hlavn analzi
		Bode start_point;//bod startu analzy	
		Bode end_point;//bod konce analzy
		Bode dir_vector;//vektor smru
		final double krok = 0.01;//mal nsobek posunovacho vektoru
		//nyn nsleduje sprvn volba koncovho a potenho bodu, jen je volen dle parametr pmky a b, body jsou potny vdy jako prsek aproximovan pmky a okraje pole
		if(a_b[1]< 0) {      //monost 1 a parametr je zporn
		
			dir_vector = new Bode(-1*krok,-a_b[1]*krok); 
			if((-(a_b[0]/a_b[1])) >= 0 && (-(a_b[0]/a_b[1])) <= 256) {
		 start_point = new Bode(-(a_b[0]/a_b[1]),0);
			}
			else {
				start_point = new Bode(256,(256*a_b[1])+a_b[0]);
				
				
			}
		 if(a_b[0] >= 0 && a_b[0] <= 256 ) {
		 
		 end_point = new Bode(0,a_b[0]);
		 }
		 else {
			 
	     end_point =  new Bode((256-a_b[0])/a_b[1],256);
	    
		 }
		 
		
		 System.out.println("<0");

		
		
		 
		
		
		
		
		
		}
		else if (a_b[1] > 0) { //Monost - a je kladn
			dir_vector = new Bode(-1*krok,-a_b[1]*krok);
			if((-(a_b[0]/a_b[1])) >= 0 && (-(a_b[0]/a_b[1])) <= 256) {
			 end_point = new Bode(-(a_b[0]/a_b[1]),0);
			}
			else {
		     end_point =  new Bode(0,a_b[0]);
				
			}
			 if(((256 * a_b[1]) + a_b[0]) >= 0 && ((256 * a_b[1]) + a_b[0]) <=256){
			 
			 start_point = new Bode(256,(256 * a_b[1]) + a_b[0]);
			 }
			 else {
				 
		     start_point = new Bode(((256-a_b[0])/a_b[1]),256); 
				 
				 
			 }
			 
			 
			 System.out.println(">0");
		}
		else { //Monost 3 a parametr je 0
			dir_vector = new Bode(1*krok, 0 );
			start_point = new Bode(0,a_b[0]);
		 end_point = new Bode(256,(256 * a_b[1]) + a_b[0]);
		 System.out.println("=0");

		}
	    double velikost_vektoru;
		double l = 0;
		Bode act_point = start_point;
		 

		
		
		velikost_vektoru = Math.pow(Math.pow(( dir_vector.getX()), 2) +    Math.pow(( dir_vector.getY()), 2), 0.5);//velikost vektru, kterm posunujeme
		double max_l =  Math.pow(Math.pow(( start_point.getX()) - ( end_point.getX()) , 2) +    Math.pow(( start_point.getY()) - ( end_point.getY()), 2), 0.5);//maximln dlka, je me stice mt
		
		Map<Double,Double> delka_energie = new TreeMap<Double,Double>();//mapa, ve kter je pro kadou dlku dan energie zaznamenanho pixelu
		Map<Double,Double> delka_energie_round = new TreeMap<Double,Double>();//mapa, ve kter je pro kadou dlku dan energie intervalu drhy
		double pocatecni_l = 0;//promnn dlek
		double l_pos_bodu = 0;
		double p; //absolutn parametr v rovnici pmky
		double energie_vyhovujicich_castic;
		p = -act_point.getX() -(a_b[1]*act_point.getY());//poten hodnota parametru
		System.out.println(dir_vector.getX());
		System.out.println(dir_vector.getY());

		System.out.println(velikost_vektoru);
	
		while (delka_energie.isEmpty()) {//tento cyklus se opakuje do doby, dokud nebude nalezen 1 bod lec na kolm pmce
			energie_vyhovujicich_castic = 0;
		for(int i = 0; i < souradnice_x.size();i++) {//kontrola vech bod, zda nele na pmce v danm posunut
		if	((Math.abs( (souradnice_x.get(i) +  (a_b[1]*souradnice_y.get(i)) + p)/(Math.pow(1 + Math.pow(a_b[1], 2), 0.5)))  <= velikost_vektoru /*vzdlenost bodu od pmky mus bt men ne velikost vektoru, kterm posunujeme*/)   &&  sekundarni_pole[souradnice_x.get(i)][souradnice_y.get(i)] != -1/*mnus jednikou jsou oznaeny body, kter byly ji algorytmem zpracovny*/) {
			
			energie_vyhovujicich_castic = energie_vyhovujicich_castic + sekundarni_pole [souradnice_x.get(i)] [souradnice_y.get(i)];//uloen energie vyhovujc buky, pokud 2 buky ve stejnm posunut maj vyhovujc vzdlenost od posunovan pmky, bere se v potaz jejich souet
			System.out.println((Math.abs( (souradnice_x.get(i) +  (a_b[1]*souradnice_y.get(i)) + p)/(Math.pow(1 + Math.pow(a_b[1], 2), 0.5)))));//vpis
			
			
			sekundarni_pole[souradnice_x.get(i)][souradnice_y.get(i)] = -1;//oznaen buky, e byla ji zpracovna
            
			
		}
		    
				
				
			}
		 
		if(energie_vyhovujicich_castic > 0) {//umstn prvnho bodu s energi do mapy
			
			delka_energie.put(0.0,energie_vyhovujicich_castic);
			break;
		}
		
		
		act_point = new Bode(act_point.getX() + ( dir_vector.getX()),act_point.getY() + ( dir_vector.getY()));//promnn danho bodu na aproximovan pmce, s nm je posunovno
		p = -act_point.getX() -(a_b[1]*act_point.getY());//prava parametru
		
		l = l + velikost_vektoru;//piten velikosti vektoru k celkov velikosti posunut
		
		
		}
		
		System.out.println(delka_energie.get(0.0));
		System.out.println(max_l);
		System.out.println(l);
		
		
		pocatecni_l = l;//poten vzdlenost
		act_point = new Bode(act_point.getX() + ( dir_vector.getX()),act_point.getY() + ( dir_vector.getY()));
		p = -act_point.getX() -(a_b[1]*act_point.getY());
		
		l = l + velikost_vektoru;


		
		
		while ((l - pocatecni_l ) <= (max_l )) {//cyklus se opakuje do doby, ne bude pmka posunuta o maximln vzdlenost
			
         //cyklus je tm stejn jako pedchoz cyklus
			energie_vyhovujicich_castic = 0;
			
			
			for(int i = 0; i < souradnice_x.size();i++) {
			if	((Math.abs( (souradnice_x.get(i) +  (a_b[1]*souradnice_y.get(i)) + p)/(Math.pow(1 + Math.pow(a_b[1], 2), 0.5))) <= velikost_vektoru + Math.pow(velikost_vektoru, 0.5) )   &&  sekundarni_pole[souradnice_x.get(i)][souradnice_y.get(i)] != -1) {
				
				energie_vyhovujicich_castic = energie_vyhovujicich_castic + sekundarni_pole [souradnice_x.get(i)] [souradnice_y.get(i)];
				
			

				sekundarni_pole[souradnice_x.get(i)][souradnice_y.get(i)] = -1;
				l_pos_bodu = l  - pocatecni_l;
				
			}
			     
				
				
			}
          if(energie_vyhovujicich_castic > 0) {
				
				delka_energie.put(l - pocatecni_l,energie_vyhovujicich_castic);
				
				
			}
			
			act_point = new Bode(act_point.getX() + ( dir_vector.getX()),act_point.getY() + (dir_vector.getY()));
			p = -act_point.getX() -(a_b[1]*act_point.getY());
			l = l + velikost_vektoru;
			}
		
		
		
		
		
		
		
		System.out.println(l_pos_bodu);
		
		
		
		//dle nsleduj ji jen pravy, zaokrouhlovn, vpisy
		//kontroln souet energi, zda nebyla vynechna dn buka
		double c_energie = 0;
		for(double a : delka_energie.keySet() ) {
		System.out.println(a + " " + delka_energie.get(a));
			c_energie += delka_energie.get(a);
			
			
		}
		if(Math.abs(c_energie - celko_energie) < 1 ) {
			
			System.out.println("V poradku");
		
		
		}
		else {// v ppad nerovnosti energi je vypsna chyba
			System.err.println("Chyba energie");
			JFrame vokno = new JFrame("Chyba");
			JOptionPane.showMessageDialog(vokno, "Chyba energie. Nesed celkov souet energi" + (c_energie - celko_energie), "InfoBox: " + "cetnost castic" , JOptionPane.INFORMATION_MESSAGE);
			System.exit(1);
			
		}
		
		
		
		
		
		
		System.out.println("" + (c_energie - celko_energie));
		
		
		
		
		
		int pocet_za_polovinou = 0;
		
		//dle nsleduje prava smru, stice je rozdlena na 2 poloviny, body ve vech polovinch spotny, oten smr mus kvli blobu bt tam, kde je vc bod
		for(double a: delka_energie.keySet()) {
			if(a < (l_pos_bodu/2)) {
			
			pocet_za_polovinou++;
			
			
		}
		}
		if (pocet_za_polovinou < (souradnice_x.size()-pocet_za_polovinou)) {
			Object[] keyArray = delka_energie.keySet().toArray();
			Map<Double,Double> pomocna_mapa  =  new TreeMap<Double,Double>();
			
			for(int i = 0; i < keyArray.length; i++) {
				pomocna_mapa.put(l_pos_bodu - (Double) keyArray[i], delka_energie.get(keyArray[i]));
				
				
			}
			delka_energie = pomocna_mapa;
			
			System.out.println("prehozeno");
			
			
		}
		
		for(double a: delka_energie.keySet()) {
			System.out.println(a + " " + delka_energie.get(a));
			
			
		}
		
		//zaokrouhlen vzdlenost jednotlivch buek od potku drhy stice a nsledn seten jejich energi do interval drhy
        double roundEnergy = 0;
		for(double i = 0; i <= Math.round(l_pos_bodu); i  += 1) {
			for(double a : delka_energie.keySet()) {
				if(Math.round(a) == i) {
					
					 roundEnergy =  roundEnergy	+ delka_energie.get(a);
					
				}
				
				
				
			}
			
			
		delka_energie_round.put(i,roundEnergy);
		roundEnergy = 0;
			
			
		}
	
		
		
		for(double a : delka_energie_round.keySet() ) {
			System.out.println(a + " " + delka_energie_round.get(a));
		}
		
		
		// zpis do souboru
		try {
			bw = new BufferedWriter(new FileWriter(way +".txt"));
			
			
			
			for(double a : delka_energie_round.keySet() ) {
				bw.write(a + " " + delka_energie_round.get(a));
				bw.newLine();
		    	bw.flush();
			}
		    			
		    	
		}
		catch (Exception e)
        {       e.printStackTrace();
                System.err.println("Do souboru se nepovedlo zapsat.");
        }
		    	
		    
				
				
			
		
		
		hlavni_pole = null;
		sekundarni_pole = null;
		
		
		
	    }
	    }


